/*
 * generated by Xtext 2.27.0
 */
package no.ntnu.idi.tdt4250.sm.xtext.serializer;

import com.google.inject.Inject;
import java.util.Set;
import no.ntnu.idi.tdt4250.sm.xtext.services.StateMachineDSLGrammarAccess;
import no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.State;
import no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.StateMachine;
import no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.StateMachineDSLPackage;
import no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.Transition;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;

@SuppressWarnings("all")
public class StateMachineDSLSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private StateMachineDSLGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == StateMachineDSLPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case StateMachineDSLPackage.STATE:
				sequence_State(context, (State) semanticObject); 
				return; 
			case StateMachineDSLPackage.STATE_MACHINE:
				sequence_StateMachine(context, (StateMachine) semanticObject); 
				return; 
			case StateMachineDSLPackage.TRANSITION:
				sequence_Transition(context, (Transition) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * <pre>
	 * Contexts:
	 *     StateMachine returns StateMachine
	 *
	 * Constraint:
	 *     (name=ID states+=State+ transitions+=Transition*)
	 * </pre>
	 */
	protected void sequence_StateMachine(ISerializationContext context, StateMachine semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     State returns State
	 *
	 * Constraint:
	 *     (name=ID initial?='init'?)
	 * </pre>
	 */
	protected void sequence_State(ISerializationContext context, State semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Transition returns Transition
	 *
	 * Constraint:
	 *     (source=[State|ID] input=STRING? target=[State|ID])
	 * </pre>
	 */
	protected void sequence_Transition(ISerializationContext context, Transition semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
